$! UPS_MONITOR.COM
$! 10-NOV-1999, David Mathog, Biology Division, Caltech
$!
$! This routine uses TCONTROL to monitor a UPS and shutdown the
$! system if appropriate.  MOdify the next couple of lines to
$! fit your system!
$!
$ theline = "tta0:"
$ bye = 5 ! minutes
$ wait_for_juice = bye*60
$ if( f$search("sys$manager:tcontrol.exe") .eqs. "")
$ then
$   reply/bell/term=opa0: "UPS_MONITOR.COM improperly configured.  TCONTROL.EXE not found"
$   write sys$output "UPS_MONITOR.COM improperly configured.  TCONTROL.EXE not found"
$   exit
$ endif
$ tcontrol:== $sys$manager:tcontrol.exe
$! for omnismart lan 2.2
$ pdown   = "''theline' dtr """" ""carrier,cts""
$ pup     = "''theline' dtr ""cts"" """" ''wait_for_juice'"
$!
$ alloc 'theline'
$ if(.not. $status)
$ then
$   reply/bell/term=opa0: "''theline' is allocated by another user, UPS_MONITOR cannot start!!!"
$   write sys$output "''theline' is allocated by another user!!!"
$   exit
$ endif
$ top:
$!
$! wait for a power failure
$!
$ now = f$time()
$ reply/bell/term=opa0: "UPS_MONITOR.COM commencing operation at ''now'"
$ write sys$output "UPS_MONITOR.COM commencing operation at ''now'"
$ tcontrol 'pdown'
$ now = f$time()
$ reply/bell/all "Warning. power failed at ''now', system shutdown in ''bye' minutes"
$ write sys$output "Warning. power failed at ''now', system shutdown in ''bye' minutes"
$!
$! Wait up to the indicated number of seconds for power to come back
$! If you do anything else in here be really, really SURE that it doesn't require
$! power to complete.
$!
$ tcontrol 'pup'
$ now = f$time()
$ if (tcontrol_high .nes. "TIMED_OUT")
$ then
$   reply/bell/all "Warning. power restored at ''now', system shutdown has been cancelled"
$   write sys$output "Warning. power failed at ''now', system shutdown has been cancelled"
$   goto top
$ endif
$!
$! it's doomsday...
$!
$! Notify the damned
$!
$ reply/bell/all "Warning. power has not been restored at ''now', system shutdown ordered"
$ write sys$output "Warning. power has not been restored at ''now', system shutdown ordered"
$!
$! hasta la vista, baby
$!
$ @sys$system:shutdown 0 "Shutdown due to power failure" NO YES "later (not known at this time)" NO "REBOOT_CHECK"
